unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Clipbrd, Vcl.ComCtrls, System.Inifiles, Winapi.Winsock, System.UITypes,
  nMail;

const
  WM_GET_CODE = (WM_APP + $0001);

type
  TFormMain = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    LabelTenantId: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    LabelAuthUri: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    LabelTokenUri: TLabel;
    Label6: TLabel;
    ComboBoxService: TComboBox;
    EditClientId: TEdit;
    EditClientSecret: TEdit;
    EditTenantId: TEdit;
    EditRedirectUri: TEdit;
    ButtonGetRefresh: TButton;
    EditRefreshToken: TEdit;
    ButtonGetAccess: TButton;
    EditAccessToken: TEdit;
    GroupBox2: TGroupBox;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    EditMailAddress: TEdit;
    EditTo: TEdit;
    EditSubject: TEdit;
    MemoBody: TMemo;
    EditNo: TEdit;
    ButtonReceive: TButton;
    ButtonSend: TButton;
    UpDownNo: TUpDown;
    ButtonReceiveImap4: TButton;
    EditMailBox: TEdit;
    Label14: TLabel;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure ButtonGetRefreshClick(Sender: TObject);
    procedure ButtonGetAccessClick(Sender: TObject);
    procedure ComboBoxServiceChange(Sender: TObject);
    procedure EditTenantIdChange(Sender: TObject);
    procedure WMGetCode(var Msg: TMessage); message WM_GET_CODE;
    procedure ButtonReceiveClick(Sender: TObject);
    procedure ButtonSendClick(Sender: TObject);
    procedure ButtonReceiveImap4Click(Sender: TObject);
  private
    { Private 錾 }
    AuthState: String;
    AuthSocket: TSocket;
    FromReceived: String;
    SubjectReceived: String;
    procedure WriteIni;
    procedure ReadIni;
    procedure CheckEnableControl;
    function GetAuthUri: String;
    function GetTokenUri: String;
  public
    { Public 錾 }
  end;

const
  OptionSection = 'OPTION';
  OptionType = 'TYPE';
  OptionClientId = 'CLIENT_ID';
  OptionClientSecret = 'CLIENT_SECRET';
  OptionTenantId = 'TENANT_ID';
  OptionRedirectUri = 'REDIRECT_URI';
  OptionRefreshToken = 'REFRESH_TOKEN';
  OptionAccessToken = 'ACCESS_TOKEN';
  OptionMailAddress = 'MAIL_ADDRESS';
  ServiceGmail = 0;
  ServiceOffice365 = 1;
  // FR[h擾 URI
  const AuthUri: array [ServiceGmail..ServiceOffice365] of string = (
    'https://accounts.google.com/o/oauth2/auth',
    'https://login.microsoftonline.com/%s/oauth2/v2.0/authorize'
  );
  // XR[v
  const AuthScope: array [ServiceGmail..ServiceOffice365] of string = (
    'https://mail.google.com/',
    'offline_access https://outlook.office.com/SMTP.Send https://outlook.office.com/POP.AccessAsUser.All https://outlook.office.com/IMAP.AccessAsUser.All'
  );
  // ̑̃p[^
  const AuthParam: array [ServiceGmail..ServiceOffice365] of string = (
    'access_type=offline',
    ''
  );
  // g[N擾 URI
  const TokenUri: array [ServiceGmail..ServiceOffice365] of string = (
    'https://accounts.google.com/o/oauth2/token',
    'https://login.microsoftonline.com/%s/oauth2/v2.0/token'
  );
  // POP3 T[o[
  const Pop3Host: array [ServiceGmail..ServiceOffice365] of string = (
    'pop.gmail.com',
    'Outlook.office365.com'
  );
  // IMAP4 T[o[
  const Imap4Host: array [ServiceGmail..ServiceOffice365] of string = (
    'imap4.gmail.com',
    'Outlook.office365.com'
  );
  // SMTP T[o[
  const SmtpHost: array [ServiceGmail..ServiceOffice365] of string = (
    'smtp.gmail.com',
    'Smtp.office365.com'
  );
  // FR[h擾 HTML
  const ResponseOk = '<html><head><meta charset="utf-8"><title>擾</title></head><body>FR[h̎擾</body></html>';
  const ResponseError = '<html><head><meta charset="utf-8"><title>擾s</title></head><body>FR[h擾G[</body></html>';
  const TEMP_MAX = 10000;
  const HEADER_MAX = 8000;
  const BODY_MAX =100000;
  const STATE_LENGTH = 16;

var
  FormMain: TFormMain;

implementation

{$R *.dfm}

procedure TFormMain.ButtonGetRefreshClick(Sender: TObject);
var
    state: array [0..TEMP_MAX] of Char;
begin
    if AuthSocket = INVALID_SOCKET then
    begin
        EditRefreshToken.Text := '';
        EditAccessToken.Text := '';
        // _CNgT[o[Jn
        AuthSocket := NMailOAuth2StartRedirectServer(PChar(EditRedirectUri.Text), PChar(ResponseOk), PChar(ResponseError), Handle, WM_GET_CODE, 0);
        if AuthSocket <> INVALID_SOCKET then
        begin
            // Xe[g쐬
            NMailMakeRandomString(state, STATE_LENGTH, 0);
            AuthState := state;
            // FR[h擾 URI Ăяo
            // uEUNďʂo
            NMailOAuth2RequestAuthorize(PChar(GetAuthUri()), PChar(EditClientId.Text), PChar(EditRedirectUri.Text), PChar(AuthScope[ComboBoxService.ItemIndex]), PChar(AuthState), nil, PChar(AuthParam[ComboBoxService.ItemIndex]), 0);
        end;
    end
    else
    begin
        // _CNgT[o[I
        NMailOAuth2EndRedirectServer(AuthSocket);
        AuthSocket := INVALID_SOCKET;
    end;
    CheckEnableControl;
end;

procedure TFormMain.ComboBoxServiceChange(Sender: TObject);
begin
    CheckEnableControl;
end;

procedure TFormMain.EditTenantIdChange(Sender: TObject);
begin
    CheckEnableControl;
end;

procedure TFormMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    // Winsock I
    NMailEndWinSock;

    // INI t@C
    WriteIni;
end;

procedure TFormMain.ReadIni;
var
  IniFileName: TFileName;
  IniFile: TIniFile;
begin
    IniFileName := ChangeFileExt(Application.ExeName, '.INI');
    IniFile := TIniFile.Create(IniFileName);
    try
        with IniFile do
        begin
            ComboBoxService.ItemIndex := ReadInteger(OptionSection, OptionType, ServiceGmail);
            EditClientId.Text := ReadString(OptionSection, OptionClientId, '');
            EditClientSecret.Text := ReadString(OptionSection, OptionClientSecret, '');
            EditTenantId.Text := ReadString(OptionSection, OptionTenantId, '');
            EditRedirectUri.Text := ReadString(OptionSection, OptionRedirectUri, '');
            EditRefreshToken.Text := ReadString(OptionSection, OptionRefreshToken, '');
            EditAccessToken.Text := ReadString(OptionSection, OptionAccessToken, '');
            EditMailAddress.Text := ReadString(OptionSection, OptionMailAddress, '');
        end;
    finally
        IniFile.Free;
    end;
end;

procedure TFormMain.FormCreate(Sender: TObject);
begin
    AuthSocket := INVALID_SOCKET;

    // Winsock 
    NMailInitializeWinSock();
    NMailSetOption(NMAIL_OPTION_HEADER_MAX, HEADER_MAX);
    NMailSetOption(NMAIL_OPTION_BODY_MAX, BODY_MAX);
    // INI t@CǍ
    ReadIni;

    CheckEnableControl;
end;

procedure TFormMain.WriteIni;
var
    IniFileName: TFileName;
    IniFile: TIniFile;
begin
    IniFileName := ChangeFileExt(Application.ExeName, '.INI');
    IniFile := TIniFile.Create(IniFileName);
    try
        with IniFile do
        begin
            WriteInteger(OptionSection, OptionType, ComboBoxService.ItemIndex);
            WriteString(OptionSection, OptionClientId, EditClientId.Text);
            WriteString(OptionSection, OptionClientSecret, EditClientSecret.Text);
            WriteString(OptionSection, OptionTenantId, EditTenantId.Text);
            WriteString(OptionSection, OptionRedirectUri, EditRedirectUri.Text);
            WriteString(OptionSection, OptionRefreshToken, EditRefreshToken.Text);
            WriteString(OptionSection, OptionAccessToken, EditAccessToken.Text);
            WriteString(OptionSection, OptionMailAddress, EditMailAddress.Text);
        end;
    finally
        IniFile.Free;
    end;
end;

procedure TFormMain.CheckEnableControl;
begin
    if ComboBoxService.ItemIndex = ServiceOffice365 Then
        EditTenantId.Enabled := True
    else
        EditTenantId.Enabled := False;

    if AuthSocket = INVALID_SOCKET Then
    begin
        ButtonGetRefresh.Caption := 'tbVg[N擾';
        if EditRefreshToken.Text = '' Then
            ButtonGetAccess.Enabled := False
        else
            ButtonGetAccess.Enabled := True;
    end
    else
        ButtonGetRefresh.Caption := '~';
    LabelAuthUri.Caption := GetAuthUri;
    LabelTokenUri.Caption := GetTokenUri;
end;

function TFormMain.GetAuthUri: String;
begin
    if ComboBoxService.ItemIndex = ServiceOffice365 Then
    begin
        // Office365 ̏ꍇ URI Ƀeig ID ܂܂
        Result := Format(AuthUri[ComboBoxService.ItemIndex], [EditTenantId.Text]);
    end
    else
        Result := AuthUri[ComboBoxService.ItemIndex];
end;

function TFormMain.GetTokenUri: String;
begin
    if ComboBoxService.ItemIndex = ServiceOffice365 Then
    begin
        // Office365 ̏ꍇ URI Ƀeig ID ܂܂
        Result := Format(TokenUri[ComboBoxService.ItemIndex], [EditTenantId.Text]);
    end
    else
        Result := TokenUri[ComboBoxService.ItemIndex];
end;

procedure TFormMain.WMGetCode(var Msg: TMessage);
var
    code: array [0..TEMP_MAX] of Char;
    state: array [0..TEMP_MAX] of Char;
    json: array [0..TEMP_MAX] of Char;
    token: array [0..TEMP_MAX] of Char;
    err: Integer;
begin
    // FR[hƃXe[g擾
    err := NMailOAuth2GetAuthorizeCode(AuthSocket, code, TEMP_MAX, state, TEMP_MAX);
    // _CNgT[o[I
    NMailOAuth2EndRedirectServer(AuthSocket);
    AuthSocket := INVALID_SOCKET;
    if err <> NMAIL_SUCCESS then
    begin
        MessageDlg('tbVg[N̎擾Ɏs܂B' + #13#10 + string(code) + string(state), mtError, [mbOk], 0);
    end
    else if AuthState <> state then
    begin
        // CSRF ΍
        MessageDlg('Xe[gقȂ܂B', mtError, [mbOk], 0);
    end
    else
    begin
        // 擾FR[hgătbVg[N擾
        err := NMailOAuth2GetRefreshToken(PChar(GetTokenUri()), PChar(EditClientId.Text), PChar(EditClientSecret.Text), PChar(EditRedirectUri.Text), code, nil, nil, nil, json, TEMP_MAX, 0);
        if err = NMAIL_SUCCESS then
        begin
            err := NMailJsonGetValue(json, 'refresh_token', token, TEMP_MAX, 0);
            if err = NMAIL_SUCCESS then
            begin
                EditRefreshToken.Text := token;
                Clipboard.AsText := EditRefreshToken.Text;
                WriteIni();
            end;
            err := NMailJsonGetValue(json, 'access_token', token, TEMP_MAX, 0);
            if err = NMAIL_SUCCESS then
                EditAccessToken.Text := token;
        end;
        if err = NMAIL_ERROR_OAUTH2_NO_TOKEN then
            MessageDlg('tbVg[N̎擾Ɏs܂B\nAJEg烍OAEgAēxsĂB', mtError, [mbOk], 0)
        else if err <> NMAIL_SUCCESS then
            MessageDlg('tbVg[N̎擾Ɏs܂B', mtError, [mbOk], 0);
    end;

    CheckEnableControl;
end;

procedure TFormMain.ButtonGetAccessClick(Sender: TObject);
var
    json: array [0..TEMP_MAX] of Char;
    token: array [0..TEMP_MAX] of Char;
    err: Integer;
begin
    // tbVg[NgăANZXg[N擾
    err := NMailOAuth2GetAccessToken(PChar(GetTokenUri()), PChar(EditClientId.Text), PChar(EditClientSecret.Text), PChar(EditRefreshToken.Text), nil, nil, json, TEMP_MAX, 0);
    if err = NMAIL_SUCCESS then
    begin
        err := NMailJsonGetValue(json, 'access_token', token, TEMP_MAX, 0);
        if err = NMAIL_SUCCESS then
        begin
            EditAccessToken.Text := token;
            Clipboard.AsText := EditAccessToken.Text;
        end;
    end;
    if err <> NMAIL_SUCCESS then
        MessageDlg('ANZXg[N̎擾Ɏs܂B', mtError, [mbOk], 0);
end;

procedure TFormMain.ButtonReceiveClick(Sender: TObject);
var
    header: array [0..HEADER_MAX] of Char;
    subject: array [0..HEADER_MAX] of Char;
    date: array [0..HEADER_MAX] of Char;
    from: array [0..HEADER_MAX] of Char;
    body: array [0..BODY_MAX] of Char;
    s: TSocket;
    no: Integer;
    mail_no: Integer;
    error_flag: Boolean;
begin
    if EditMailAddress.Text = '' then
    begin
        MessageDlg('[AhX͂ĂB', mtError, [mbOK], 0);
        exit;
    end;
    if EditAccessToken.Text = '' then
    begin
        MessageDlg('ANZXg[N擾ĂB', mtError, [mbOK], 0);
        exit;
    end;
    if MessageDlg('[M܂H', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
    begin
        s := NMailPop3ConnectSsl(PChar(Pop3Host[ComboBoxService.ItemIndex]), NMAIL_POP3_SSL_PORT, NMAIL_SSL_TLS1, nil);
        if s <> INVALID_SOCKET then
        begin
            error_flag := true;
            no := NMailPop3AuthenticateMode(s, PChar(EditMailAddress.Text), PChar(EditAccessToken.Text), NMAIL_IMAP4_AUTH_OAUTH2);
            if no >= 0 then
            begin
                mail_no := StrToInt(EditNo.Text);
                if mail_no <= no then
                begin
                    if NMailPop3GetMail(s, mail_no, subject, date, from, header, body, nil, nil) = NMAIL_SUCCESS then
                    begin
                        EditSubject.Text := subject;
                        EditTo.Text := from;
                        MemoBody.Lines.Text := body;
                        SubjectReceived := subject;
                        FromReceived := from;
                        error_flag := false;
                    end
                end
                else
                    MessageDlg('w̔ԍ̃[݂܂B', mtError, [mbOK], 0);
            end;
            if error_flag then
            begin
                NMailGetMessage(NMAIL_GET_ERROR_MESSAGE, header, HEADER_MAX);
                MessageDlg(header, mtError, [mbOK], 0);
            end;
            NMailPop3Close(s);
        end
        else
            MessageDlg('ڑG[', mtError, [mbOK], 0);
    end;
end;

procedure TFormMain.ButtonReceiveImap4Click(Sender: TObject);
var
    header: array [0..HEADER_MAX] of Char;
    subject: array [0..HEADER_MAX] of Char;
    date: array [0..HEADER_MAX] of Char;
    from: array [0..HEADER_MAX] of Char;
    body: array [0..BODY_MAX] of Char;
    s: TSocket;
    count: Integer;
    mail_no: Integer;
    error_flag: Boolean;
    uid: Integer;
begin
    if EditMailAddress.Text = '' then
    begin
        MessageDlg('[AhX͂ĂB', mtError, [mbOK], 0);
        exit;
    end;
    if EditAccessToken.Text = '' then
    begin
        MessageDlg('ANZXg[N擾ĂB', mtError, [mbOK], 0);
        exit;
    end;
    if MessageDlg('[M܂H', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
    begin
        s := NMailImap4ConnectSsl(PChar(Imap4Host[ComboBoxService.ItemIndex]), NMAIL_IMAP4_SSL_PORT, NMAIL_SSL_TLS1, nil);
        if s <> INVALID_SOCKET then
        begin
            error_flag := true;
            if NMailImap4Authenticate(s, PChar(EditMailAddress.Text), PChar(EditAccessToken.Text), NMAIL_IMAP4_AUTH_OAUTH2) = NMAIL_SUCCESS then
            begin
                if NMailImap4SelectMailBox(s, PChar(EditMailBox.Text), FALSE) >= 0 then
                begin
                    mail_no := StrToInt(EditNo.Text);
                    count := NMailImap4SearchMail(s, NMAIL_IMAP4_SEARCH_UNDELETED, nil, NMAIL_IMAP4_USE_UID);
                    if mail_no <= count then
                    begin
                        NMailImap4GetSearchMailResult(s, mail_no - 1, uid);
                        if NMailImap4GetMail(s, uid, subject, date, from, header, body, nil, nil, NMAIL_IMAP4_USE_UID) = NMAIL_SUCCESS then
                        begin
                            EditSubject.Text := subject;
                            EditTo.Text := from;
                            MemoBody.Lines.Text := body;
                            SubjectReceived := subject;
                            FromReceived := from;
                            error_flag := false;
                        end;
                    end
                    else
                        MessageDlg('w̔ԍ̃[݂܂B', mtError, [mbOK], 0);
                end;
            end;
            if error_flag then
            begin
                NMailGetMessage(NMAIL_GET_ERROR_MESSAGE, header, HEADER_MAX);
                MessageDlg(header, mtError, [mbOK], 0);
            end;
            NMailImap4Close(s);
        end
        else
            MessageDlg('ڑG[', mtError, [mbOK], 0);
    end;
end;

procedure TFormMain.ButtonSendClick(Sender: TObject);
var
    port: Integer;
    ssl_mode: Integer;
    s: TSocket;
    msg: array [0..HEADER_MAX] of Char;
    error_flag: Boolean;
begin
    if EditMailAddress.Text = '' then
    begin
        MessageDlg('[AhX͂ĂB', mtError, [mbOK], 0);
        exit;
    end;
    if EditAccessToken.Text = '' then
    begin
        MessageDlg('ANZXg[N擾ĂB', mtError, [mbOK], 0);
        exit;
    end;
    if EditTo.Text = '' then
    begin
        MessageDlg('͂ĂB', mtError, [mbOK], 0);
        exit;
    end;
    if EditSubject.Text = '' then
    begin
        MessageDlg('͂ĂB', mtError, [mbOK], 0);
        exit;
    end;
    if MemoBody.Lines.Text = '' then
    begin
        MessageDlg('{͂ĂB', mtError, [mbOK], 0);
        exit;
    end;
    if (EditTo.Text = FromReceived) and (EditSubject.Text = SubjectReceived) then
    begin
        MessageDlg('M[̂܂ܕԑĂ܂܂B' + #13#10 + '⌏ύXĂB', mtError, [mbOK], 0);
        exit;
    end;
    if MessageDlg('[𑗐M܂H', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
    begin
        port := NMAIL_SMTP_SSL_PORT;
        ssl_mode := NMAIL_SSL_TLS1;
        if ComboBoxService.ItemIndex = serviceOffice365 then
        begin
            port := NMAIL_SMTP_SUBMISSION_PORT;
            ssl_mode := ssl_mode or NMAIL_SSL_STARTTLS;
        end;
        s := NMailSmtpConnectSsl(PChar(SmtpHost[ComboBoxService.ItemIndex]), port, ssl_mode, nil);
        if s <> INVALID_SOCKET then
        begin
            error_flag := true;
            if NMailSmtpAuthenticate(s, PChar(SmtpHost[ComboBoxService.ItemIndex]), PChar(EditMailAddress.Text), PChar(EditAccessToken.Text), NMAIL_SMTP_AUTH_OAUTH2) = NMAIL_SUCCESS then
            begin
                if NMailSmtpSendMailEx(s, PChar(EditTo.Text), nil, nil, PChar(EditMailAddress.Text), PChar(EditSubject.Text), PChar(MemoBody.Lines.Text), nil, nil, nil, 0) = NMAIL_SUCCESS then
                begin
                    MessageDlg('M܂B', mtInformation, [mbOK], 0);
                    error_flag := false;
                end
            end;
            if error_flag then
            begin
                NMailGetMessage(NMAIL_GET_ERROR_MESSAGE, msg, HEADER_MAX);
                MessageDlg(msg, mtError, [mbOK], 0);
            end;
        end
        else
            MessageDlg('ڑG[', mtError, [mbOK], 0);
    end;
end;

end.
